/*
 * Copyright (C) 1999-2004 <a href="mailto:mandarax@jbdietrich.com">Jens Dietrich</a>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.mandarax.lib;


import org.mandarax.kernel.Predicate;
import org.mandarax.util.PredicateUtils;
import org.mandarax.util.logging.LogCategories;

/**
 * Abstract super class mandarax lib predicates.
 * @author <A HREF="mailto:mandarax@jbdietrich.com">Jens Dietrich</A>
 * @version 3.3.1 <9 August 2004>
 * @since 1.6
 */
public abstract class AbstractPredicate extends LibObject implements Predicate {

	public final static String[] SLOT_NAMES_0 = {};
	public final static String[] SLOT_NAMES_1 = {"slot1"};
	public final static String[] SLOT_NAMES_2 = {"slot1","slot2"};
	public final static String[] SLOT_NAMES_3 = {"slot1","slot2","slot3"};
    /**
     * Indicates whether the object (usually a term or a clause set) can be performed
     * using the java semantics. All Mandarax lib predicates support this.
     * @return true
     */
    public boolean isExecutable() {
        return true;
    }

    /**
     * Convert the object to a string.
     * @return a string
     */
    public String toString() {
        return(getName () == null)
              ? super.toString ()
              : getName ();
    }
	/**
	 * Get the slot names.
	 * @return an array of strings, the length of the array is the same as
	 * the length of the array of terms (the structure of the predicate)
	 */
	public String[] getSlotNames() {
		int structLength = getStructure().length;
		if (structLength==0) return SLOT_NAMES_0;
		else if (structLength==1) return SLOT_NAMES_1;
		else if (structLength==2) return SLOT_NAMES_2;
		else if (structLength==3) return SLOT_NAMES_3;
		else {
			String[] slotNames = new String[getStructure().length];
			for (int i=0;i<slotNames.length;i++) slotNames[i] = PredicateUtils.getSlotName(this,i); 
			return slotNames;
		}
		
	}
	/**
	 * Set the slot names.
	 * @param names an array of strings, the length of the array is the same as
	 * the length of the array of terms (the structure of the predicate)
	 */
	public void setSlotNames(String[] names) {
		LogCategories.LOG_KB.debug("Ignore attempt to set slot names for lib predicate");
		// ignored
	}
	/**
	 * Indicates whether the slot names can be modified.
	 * @return a boolean
	 */
	public boolean slotNamesCanBeEdited() {
		return false;
	}
	

}
